/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef	__GANDI_CH_H
#define	__GANDI_CH_H	1

#include <ncurses.h>

extern size_t GANDI_ch_len(const chtype *t);
extern chtype *GANDI_ch_dup(const chtype *t);
extern int GANDI_ch_mvwaddch(WINDOW *w, int y, int x, const chtype c);
extern int GANDI_ch_mvwaddnstr(WINDOW *w, int y, int x, const chtype *t,		int n);
extern size_t GANDI_ch_longest(const chtype **text, size_t *index);
extern void GANDI_ch_stat_cr(const char *cr, size_t *lines, size_t *cols,		size_t *index);
extern chtype **GANDI_ch_2text_cr(const char *cr, size_t lines, chtype a);
extern void GANDI_ch_stat(const chtype **text, size_t *lines, size_t *cols,		size_t *index);
extern char *GANDI_ch_2cr(const chtype **text);
extern int GANDI_ch_cmp(const chtype *s1, const chtype *s2, chtype mask);
extern chtype *GANDI_ch_cpy(chtype *dest, const chtype *src);
extern chtype **GANDI_ch_2list(const chtype *t);

#define GANDI_ch_ATTRIBUTES(w)	( (w) ^ ( ((w) & (A_CHARTEXT)) | ((w) & (A_COLOR)) ) )

#endif /* gandi_ch.h  */

