/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDI_TIMER_H

#define _GANDI_TIMER_H	1

#include "gandi_core.h"
#include <sys/time.h>

//timer action handler
typedef bool(* GANDIact_timer)(void *);

//structure to contain all information concerning timer
typedef struct _GANDIT_timer GANDIT_timer;

struct _GANDIT_timer {
	struct timeval *period;	// Period of wakes
	struct timeval *last;	// Time of the last wake
	GANDIact_timer handler;	// Function to be called on wake
};

/*
struct timeval {
	long tv_sec;	//seconds
	long tv_usec;	//microseconds
};
tv_usec MUST be in the range [0..(1e6 - 1)]
Do not think, that structure {0, 2e6} is same as {2, 0} (the last is right)
*/

//attaches timer structure to the specified widget
extern GANDIT_timer *GANDI_timer_attach(void *w);
//removes timer structure from the specified widget
extern void GANDI_timer_dettach(void *w);

#define GANDI_getwidget_timer_handler(w)						( (GANDI_vtw(w)->timer) ? GANDI_vtw(w)->timer->handler : NULL )
#define GANDI_getwidget_timer_last(w)							( (GANDI_vtw(w)->timer) ? GANDI_vtw(w)->timer->last : NULL )
#define GANDI_getwidget_timer_period(w)							( (GANDI_vtw(w)->timer) ? GANDI_vtw(w)->timer->period : NULL )
#define GANDI_setwidget_timer_period(w, sec, usec)					if (GANDI_vtw(w)->timer) {								GANDI_vtw(w)->timer->period->tv_sec = (sec);					GANDI_vtw(w)->timer->period->tv_usec = (usec);				}
#define GANDI_setwidget_timer_last(w, sec, usec)					if (GANDI_vtw(w)->timer) {								GANDI_vtw(w)->timer->last->tv_sec = (sec);					GANDI_vtw(w)->timer->last->tv_usec = (usec);				}
#define GANDI_getact_timer(w)								( (GANDI_vtw(w)->timer) ? GANDI_vtw(w)->timer->handler :				(GANDIact_timer)NULL )
#define GANDI_setact_timer(w,f)								if ( GANDI_vtw(w)->timer ) GANDI_vtw(w)->timer->handler = (f)

#define GANDI_setwidget_timer_handler	GANDI_setact_timer

#endif //gandi_timer.h

