/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_CHECK_BOX_H

#define _GANDIW_CHECK_BOX_H	1

#include "gandiw_text_label.h"

typedef struct _GANDIW_check_box GANDIW_check_box;

struct _GANDIW_check_box {
	GANDIW_widget *		core;		//common for all widgets
	GANDIW_text_label *	capwid;		//button caption
	attr_t			win_attr;
	short			win_pair;
	short			checked;	//whether it's checked
	bool			tristate;	//whether widget has 3 states
};

extern GANDIW_check_box GANDIW_check_box_dfl;
extern GANDIW_widget GANDIW_check_box_dfl_core;

extern GANDIW_check_box *GANDIW_check_box_make(int nlines, int ncols, int by,		int bx, void *parent, const chtype *caption);
extern int GANDIW_check_box_resize(GANDIW_check_box *w, int nlines, int ncols,		int by, int bx);
extern void GANDIW_check_box_ch_checked(GANDIW_check_box *w);
extern void GANDIW_check_box_refresh(GANDIW_check_box *w);
extern void GANDIW_check_box_set_attrs(GANDIW_check_box *w, attr_t attr,		short pair);
extern int GANDIW_check_box_driver(GANDIW_check_box *w, int k);

#define GANDIW_check_box_vtw(w)	((GANDIW_check_box *)w)

#define GANDIW_check_box_caption(w)							( (GANDIW_text_label *)(GANDIW_check_box_vtw(w)->capwid) )
#define GANDIW_check_box_get_capwid(w)	GANDIW_check_box_caption(w)

#define GANDIW_check_box_window(w)	GANDI_get_Nwindow(w, 0)

#define GANDIW_check_box_get_win_attr(w) ( GANDIW_check_box_vtw(w)->win_attr )
extern attr_t GANDIW_check_box_set_win_attr(GANDIW_check_box *w, attr_t val);

#define GANDIW_check_box_get_win_pair(w) ( GANDIW_check_box_vtw(w)->win_pair )
extern short GANDIW_check_box_set_win_pair(GANDIW_check_box *w, short val);

#define GANDIW_check_box_get_tristate(w) ( GANDIW_check_box_vtw(w)->tristate )
extern short GANDIW_check_box_set_tristate(GANDIW_check_box *w, short val);

extern chtype GANDIW_check_box_get_bullet(GANDIW_check_box *w);

#define GANDIW_check_box_get_checked(w) ( GANDIW_check_box_vtw(w)->checked )

#define GANDIW_check_box_draw_bullet(w) {						mvwaddstr(GANDIW_check_box_window(w), 0, 0, "[ ]");				if (GANDIW_check_box_get_checked(w))							mvwaddch(GANDIW_check_box_window(w), 0, 1,						GANDIW_check_box_get_bullet(w));					wmove(GANDIW_check_box_window(w), 0, 1); }

#define GANDIW_check_box_set_checked(w,value) {						GANDIW_check_box_vtw(w)->checked = value;					GANDIW_check_box_draw_bullet(w); }

#define GANDIW_check_box_2text(w,cr)							GANDI_ch_2text_cr((cr), 1,								GANDIW_check_box_get_win_attr(								(w) ? (w) : &GANDIW_check_box_dfl ) |					COLOR_PAIR( GANDIW_check_box_get_win_pair(						(w) ? (w) : &GANDIW_check_box_dfl ) )				)

#endif

