/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_COMBO_BOX_H

#define _GANDIW_COMBO_BOX_H	1

#include "gandiw_text_edit.h"
#include "gandiw_list_box.h"

typedef struct _GANDIW_combo_box GANDIW_combo_box;

struct _GANDIW_combo_box {
	GANDIW_widget *		core;		//common for all widgets
	GANDIW_text_edit *	txtwid;		//text
	GANDIW_list_box *	lstwid;		//pop-up list box
	attr_t			btn_attr;	//attributes of button
	short			btn_pair;	//color pair of button
	int			limit;		//the maximum number of
						//	displayed items
};

extern GANDIW_combo_box GANDIW_combo_box_dfl;
extern GANDIW_widget GANDIW_combo_box_dfl_core;

extern GANDIW_combo_box *GANDIW_combo_box_make(int nlines, int ncols, int by,		int bx, void *parent);
extern int GANDIW_combo_box_resize(GANDIW_combo_box *w, int nlines, int ncols,		int by, int bx);
extern void GANDIW_combo_box_open(GANDIW_combo_box *w);
extern void GANDIW_combo_box_close(GANDIW_combo_box *w);
extern int GANDIW_combo_box_txtwid_driver(GANDIW_text_edit *w, int k);
extern void GANDIW_combo_box_lstwid_post_focus(void *w);
extern GANDIT_drvret GANDIW_combo_box_lstwid_driver(GANDIW_list_box *w, int k);

#define GANDIW_combo_box_vtw(w)	((GANDIW_combo_box *)w)

#define GANDIW_combo_box_btn(w)		GANDI_get_Nwindow((w), 0)
#define GANDIW_combo_box_lstwid(w)	( GANDIW_combo_box_vtw(w)->lstwid )
#define GANDIW_combo_box_txtwid(w)	( GANDIW_combo_box_vtw(w)->txtwid )

#define GANDIW_combo_box_get_btn_attr(w) ( GANDIW_combo_box_vtw(w)->btn_attr )
extern attr_t GANDIW_combo_box_set_btn_attr(GANDIW_combo_box *w, attr_t val);

#define GANDIW_combo_box_get_btn_pait(w) ( GANDIW_combo_box_vtw(w)->btn_pair )
extern short GANDIW_combo_box_set_btn_pair(GANDIW_combo_box *w, short val);

#define GANDIW_combo_box_get_limit(w) ( GANDIW_combo_box_vtw(w)->limit )
extern int GANDIW_combo_box_set_limit(GANDIW_combo_box *w, int val);

#endif

