/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_FILE_VIEW_H

#define _GANDIW_FILE_VIEW_H	1

#include "gandiw_list_box.h"
#include <dirent.h>

typedef struct _GANDIW_file_list GANDIW_file_list;

struct _GANDIW_file_list {
	GANDIW_widget *		core;	//common for all widgets
	GANDIW_list_box *	lstwid;	//list box
	char *			pwd;	//work directory
	bool			hide;	//do not show hidden files
	bool			sort;	//throw files at the end
};

extern GANDIW_file_list GANDIW_file_list_dfl;
extern GANDIW_widget GANDIW_file_list_dfl_core;

extern GANDIW_file_list *GANDIW_file_list_make(int nlines, int ncols, int by,		int bx, void *parent);
extern void GANDIW_file_list_kill(GANDIW_file_list *w);
extern int GANDIW_file_list_resize(GANDIW_file_list *w, int nlines, int ncols,		int by, int bx);
extern bool GANDIW_file_list_act_sel(GANDIW_list_box *w, size_t i);
extern int GANDIW_file_list_show(GANDIW_file_list *w);
extern int GANDIW_file_list_sort(GANDIW_file_list *w);

#define GANDIW_file_list_vtw(w)		( (GANDIW_file_list *)(w) )
#define GANDIW_file_list_lstwid(w)	( GANDIW_file_list_vtw(w)->lstwid )

#define GANDIW_file_list_get_pwd(w)	( GANDIW_file_list_vtw(w)->pwd )
#define GANDIW_file_list_get_hide(w)	( GANDIW_file_list_vtw(w)->hide )
#define GANDIW_file_list_get_sort(w)	( GANDIW_file_list_vtw(w)->sort )

extern char *GANDIW_file_list_set_pwd(GANDIW_file_list *w, char *val);
extern bool GANDIW_file_list_set_hide(GANDIW_file_list *w, bool val);
extern bool GANDIW_file_list_set_sort(GANDIW_file_list *w, bool val);

#endif // gandiw_file_list.h

