/* The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _GANDIW_TEXT_LABEL_H

#define _GANDIW_TEXT_LABEL_H		1

#include "gandi_core.h"

typedef struct _GANDIW_text_label GANDIW_text_label;

struct _GANDIW_text_label {
	GANDIW_widget *		core;		//common for all widgets
	attr_t			win_attr;
	short			win_pair;
	bool			allow_show;
	chtype *		caption;
	bool			autosize;
	short			alignment;
};

extern GANDIW_widget GANDIW_text_label_dfl_core;
extern GANDIW_text_label GANDIW_text_label_dfl;

extern short GANDIW_text_label_align_left;
extern short GANDIW_text_label_align_right;
extern short GANDIW_text_label_align_centre;

extern GANDIW_text_label *GANDIW_text_label_make(int nlines, int ncols,			int by, int bx, void *parent, const chtype *caption);
extern int GANDIW_text_label_resize(GANDIW_text_label *w, int nlines, int ncols,	int by, int bx);
extern void GANDIW_text_label_kill(GANDIW_text_label *w);
extern void GANDIW_text_label_set_attrs(GANDIW_text_label *w, attr_t attr,		short pair);
extern void GANDIW_text_label_show(GANDIW_text_label *w);

#define GANDIW_text_label_vtw(w)	( (GANDIW_text_label *)w )

#define GANDIW_text_label_get_caption(w) ( GANDIW_text_label_vtw(w)->caption )
extern chtype *GANDIW_text_label_set_caption(GANDIW_text_label *w,			const chtype *caption);

#define GANDIW_text_label_get_autosize(w)						( GANDIW_text_label_vtw(w)->autosize )
extern bool GANDIW_text_label_set_autosize(GANDIW_text_label *w, bool val);

#define GANDIW_text_label_get_alignment(w)						( GANDIW_text_label_vtw(w)->alignment )
extern short GANDIW_text_label_set_alignment(GANDIW_text_label *w, short val);

#define GANDIW_text_label_get_win_attr(w)						( GANDIW_text_label_vtw(w)->win_attr )
extern attr_t GANDIW_text_label_set_win_attr(GANDIW_text_label *w, attr_t val);

#define GANDIW_text_label_get_win_pair(w)						( GANDIW_text_label_vtw(w)->win_pair )
extern short GANDIW_text_label_set_win_pair(GANDIW_text_label *w, short val);

#define GANDIW_text_label_get_allow_show(w)						( GANDIW_text_label_vtw(w)->allow_show )
extern bool GANDIW_text_label_set_allow_show(GANDIW_text_label *w, bool val);

#define GANDIW_text_label_2text(w,cr)							GANDI_ch_2text_cr((cr), 1,								GANDIW_text_label_get_win_attr(								(w) ? (w) : &GANDIW_text_label_dfl ) |					COLOR_PAIR( GANDIW_text_label_get_win_pair(						(w) ? (w) : &GANDIW_text_label_dfl ) )				)

#endif

